UNIT Param2;

                                INTERFACE

TYPE

  TParameters = object
                aantal      : byte;
                procedure init;
                function ZoekGetalSwitch(tekst : string; default : real) : real;
                function Help : boolean;
                function ZoekTekstSwitch(tekst : string; default : string) : string;
                function ZoekSwitch(tekst : string) : boolean;
                procedure verwijderswitches;
                function haal(nummer : byte) : string;
                private
                  uitgesloten : array[1..10] of boolean;
                  function isSwitch(str : string) : boolean;
                end;


FUNCTION UpperCase(str : string) : string;

VAR

  Parameters : TParameters;


                                IMPLEMENTATION


PROCEDURE TParameters.Init;

  var

    teller : byte;

  begin

    for teller:=1 to 10 do uitgesloten[teller]:=false;
    aantal:=paramcount;

  end;


FUNCTION TParameters.ZoekGetalSwitch(tekst : string;default : real) : real;

  var

    str : string;
    waarde : real;
    error : integer;

  begin

    str:=ZoekTekstSwitch(tekst,'dummy...dummy...dummy');
    val(str,waarde,error);
    if error<>0 then waarde:=default;
    ZoekGetalSwitch:=waarde;

  end;


FUNCTION TParameters.Help : boolean;

  begin

    Help:=Zoekswitch('?') or zoekswitch('/?');

  end;


FUNCTION TParameters.ZoekTekstSwitch(tekst : string; default : string) : string;

  var

   teller : byte;
   lengte : byte;

  begin

    tekst:=uppercase(tekst);
    lengte:=length(tekst);
    for teller:=1 to paramcount do
      begin
      if (uppercase(copy(paramstr(teller),1,lengte))=tekst)
      and not(uitgesloten[teller]) then
        begin
        tekst:=paramstr(teller);
        if length(tekst)>lengte then delete(tekst,1,lengte) else tekst:=default;
        ZoekTekstSwitch:=tekst;
        exit;
        end;
      end;
    ZoekTekstSwitch:=default;

  end;


FUNCTION TParameters.ZoekSwitch (tekst : string) : boolean;

  var

    teller : byte;
    lengte : byte;

  begin

    tekst:=uppercase(tekst);
    lengte:=length(tekst);
    for teller:=1 to paramcount do
      begin
      if (uppercase(copy(paramstr(teller),1,lengte))=tekst)
      and not(uitgesloten[teller]) then
        begin
        ZoekSwitch:=true;
        exit;
        end;
      end;
    ZoekSwitch:=false;

  end;


PROCEDURE TPArameters.VerwijderSwitches;

  var

    teller : byte;

  begin

    for teller:=1 to paramcount do
      begin
      if isswitch(paramstr(teller)) and not(uitgesloten[teller]) then
         begin
         uitgesloten[teller]:=true;
         aantal:=aantal-1;
         end;
      end;

  end;


FUNCTION TParameters.Haal(nummer : byte) : string;

  var

    nummerdiemeeteld : byte;
    teller           : byte;

  begin

    nummerdiemeeteld:=0;
    for teller:=1 to paramcount do
      begin
      if not(uitgesloten[teller]) then nummerdiemeeteld:=nummerdiemeeteld+1;
      if nummerdiemeeteld=nummer then
         begin
         haal:=paramstr(teller);
         exit;
         end;
      end;

  end;


function TParameters.isswitch(str : string) : boolean;

  begin

    if copy(str,1,1)='/' then isswitch:=true else isswitch:=false

  end;


function uppercase(str : string) : string;

  var

    teller : byte;

  begin

    for teller:=1 to length(str) do str[teller]:=upcase(str[teller]);
    uppercase:=str;

  end;


BEGIN

  Parameters.Init;

END.