UNIT StrList;

                INTERFACE

USES

  Graph,
  GraphLst,
  Algemeen;


TYPE

  PStringREcord =^TstringRecord;
  TStringRecord = record
                  Str : String;
                  Next : PStringRecord;
                  end;
  PStringList = ^TStringList;
  TStringList = object
                AantalRegels : word;
                Start : PStringRecord;
                huidige : PStringrecord;
                MaxLengte : byte;
                constructor init;
                procedure reset;
                function leesString : PString;
                procedure ZetStringNaar(waarde : byte);
                procedure VoegToe(str : string);
                destructor done;
                private
                  LaatsteWasLedig : boolean;
                  procedure InterneVoegToe(str : string);
                  procedure berekenlengte;
                end;


function dellastword(var str : string; naarpositie : byte) : string;


                          IMPLEMENTATION

CONST

  WoordTekens = ['a'..'z', 'A'..'Z', '0'..'9', '_', '[', ']'];


function dellastword(var str : string; naarpositie : byte) : string;

  label

    afgelopen;


  var

    Deel1 : string;
    Deel2 : string;
    WoordBezig : boolean;
    Beginwoord : byte;
    eindWoord  : byte;
    Teller     : byte;
    teken      : char;
    stop       : boolean;
    kapaf      : byte;

  begin

    if naarpositie=0 then
      begin
      closegraph;
      writeln('Het schema is te breed voor n blad, sorry ...');
      halt;
      end;
    Deel1:=Str;
    Deel2[0]:=#0;
    teller:=0;
    BeginWoord:=1;
    WoordBezig:=true;
    stop:=false;
    if length(deel1)<naarpositie then
      begin
      dellastword:='';
      exit;
      end;
    while not(stop) do
      begin
      teller:=teller+1;
      if teller>length(deel1) then
        begin
        eindwoord:=length(deel1);
        stop:=true;
        end;
      if not(stop) then
        begin
        teken:=Deel1[teller];
        if teken in woordtekens then
           begin
           if not(woordbezig) then beginwoord:=teller;
           Woordbezig:=true;
           end else
           begin
           if woordbezig then eindwoord:=teller;
           woordbezig:=false;
           end;
        if not(woordbezig) and (teller>naarpositie) then stop:=true;
        end;
      end;
    if (beginwoord=1) then
       begin
       kapaf:=naarpositie+1;
       goto afgelopen
       end;
    if (beginwoord<=naarpositie) then
       begin
       kapaf:=beginwoord;
       if eindwoord-beginwoord>naarpositie then kapaf:=naarpositie+1;
       end else kapaf:=naarpositie+1;
afgelopen:
    deel2:=copy(deel1,kapaf,length(deel1)-kapaf+1);
    delete(deel1,kapaf,length(deel1)-kapaf+1);
    str:=deel1;
    dellastword:=deel2;

  end;


procedure TStringList.ZetStringNaar(waarde : byte);

  var

    over1 : string;
    hudige : PStringRecord;
    over2 : string;
    onthoud : string;
    stop : boolean;

  begin

    stop:=false;
    hudige:=huidige;
    if length(hudige^.str)>waarde then
       begin
       if hudige<>nil then over1:=DelLastWord(hudige^.str,waarde);
       while (hudige<>nil) and not(stop) do
         begin
         if hudige^.next=nil then
              begin
              InterneVoegtoe(over1);
              stop:=true;
              end
            else
              begin
              if length(over1)>(255-length(hudige^.next^.str)) then
                 begin
                 over2:=DelLastWord(hudige^.next^.str,255-length(over1));
                 over1:=over2;
                 hudige:=hudige^.next;
                 end else stop:=true;
              insert(over1,hudige^.next^.str,1);
              end;
         end;
       end;
    if huidige<>nil then huidige:=huidige^.next;
    Berekenlengte;

  end;


constructor TStringList.init;

  begin

    AantalRegels:=0;
    Start:=nil;
    Huidige:=nil;
    Maxlengte:=0;
    Laatstewasledig:=false;

  end;


procedure TStringList.reset;

  begin

    huidige:=start;
    Laatstewasledig:=false;

  end;


function TStringList.LeesString : PString;

  begin

    if huidige=nil then leesstring:=PLedig else
       begin
       leesstring:=@huidige^.str;
       huidige:=huidige^.next;
       end;

  end;


procedure TStringList.Berekenlengte;

  var

    hudige : PStringRecord;

  begin

    hudige:=start;
    Maxlengte:=0;
    while hudige<>nil do
       begin
       if length(hudige^.str)>maxlengte then maxlengte:=length(hudige^.str);
       hudige:=hudige^.next;
       end;

  end;


procedure TStringList.InterneVoegToe (str : string);

  var

    locale : PStringRecord;

  begin

    locale:=start;
    if locale=nil
      then
        begin
        new(start);
        start^.next:=nil;
        start^.str:=str;
        end
      else
        begin
        while not(locale^.next=nil) do locale:=locale^.next;
        new(locale^.next);
        locale^.next^.next:=nil;
        locale^.next^.str:=str;
        end;
    aantalregels:=aantalregels+1;
    if length(str)>maxlengte then maxlengte:=length(str);

  end;


procedure TStringList.Voegtoe(str : string);

  begin

    if laatstewasledig then InterneVoegtoe('');
    if str[0]=#0 then laatstewasledig:=true else internevoegtoe(str);

  end;


destructor TStringList.done;

  var

    volgende : PStringRecord;
    Deze  : PStringRecord;

  begin

    Deze:=start;
    if deze<>nil then
      begin
      repeat
        volgende:=Deze^.next;
        if deze<>nil then dispose(Deze);
        Deze:=volgende;
      until Deze=nil;
      end;
    aantalregels:=0;

  end;


END.
