PROGRAM PrintNS;

USES

  Printer,
  Filelist,
  Dos,
  Crt,
  Codering,
  Algemeen,
  Param2;

VAR

  Filename : pathstr;
  VraagAchterFiles  : boolean;
  Stop              : boolean;
  nummer            : byte;
  bestanden         : TFileList;
  bestand           : file of char;
  data              : char;
  recursie          : boolean;
  percentage        : real;
  positie           : longint;
  paginaeinde       : boolean;
  X, Y              : byte;
  str               : string;
  grootte           : longint;
  bruikbaar         : boolean;

PROCEDURE TekenToPrn(teken : char);

  var

    error : word;

  begin

    repeat
      {$I-}
      Write(lst,teken);
      {$I+}
      error:=IOresult;
    until error=0;

  end;


PROCEDURE GeefHelp;

  begin

    writeln('PrintNS  [/E] [/R] filenames');
    writeln;
    writeln('   [/E]      : voegt tussen twee bestanden een pagina einde');
    writeln('   [/R]      : doorzoekt ook subdir''s');
    writeln('   filenames : namen van de te printen files (eventueel wildcards)');
    writeln;
    writeln('Esc = cancel printing');

  end;


BEGIN

  HighVideo;
  (*Pas2ns Print program version 1.0 Copyright (c) Werner Van Belle 1992*)
  Writeln(Code(#18#230#181#37#29#181#200#18#135#238#29#209#200#125 +
  #135#95#126#135#230#2#200#163#115#135#181#238#95#29#200#94#75#31 +
  #200#2#230#241#115#200#107#167#200#150#115#135#29#115#135#200#112 +
  #230#29#200#13#115#119#119#115#200#94#214#214#37));
  Lowvideo;
  if (paramcount=0) or parameters.Help then
    begin
    GeefHelp;
    halt;
    end;
  recursie:=parameters.zoekswitch('/R');
  paginaeinde:=parameters.zoekswitch('/E');
  parameters.VerwijderSwitches;
  nummer:=parameters.aantal;
  stop:=false;
  if nummer=0 then vraagachterfiles:=true else vraagachterfiles:=false;
  repeat
  if nummer=0 then
     begin
     if vraagachterfiles then
       begin
       Write('Filename : ');
       Readln(Filename);
       end else stop:=true;
     end else
       begin
       filename:=parameters.haal(nummer);
       nummer:=nummer-1;
       end;
  if filename='' then stop:=true;
  if not(stop) then
     begin
     bestanden.reset(filename,recursie);
     while not bestanden.Laatstefile do
       begin
       if (bestanden.attribuut=archive) or (bestanden.attribuut=0) then
         begin
         assign(bestand,bestanden.pad);
         reset(bestand);
         Write('    ',bestanden.pad,' : ');
         X:=WhereX;
         Y:=WhereY;
         str:='';
         positie:=0;
         while not(eof(bestand)) and not(positie=74) do
            begin
            read(bestand,data);
            positie:=positie+1;
            str:=str+data;
            end;
         if str='Pas2ns version 1.0 Copyright (C) Werner Van Belle 1992'#13#10 +
         'Print data file'#13#10#26 then Bruikbaar:=true else bruikbaar:=false;
         if bruikbaar then
           begin
           grootte:=filesize(bestand);
           write('0 % ');
           Gotoxy(X,Y);
           for positie:=75 to grootte do
             begin
             read(bestand,data);
             TekenToPrn(data);
             Write(((positie*100) div grootte),' %  ');
             gotoxy(X,Y);
             if keypressed then
                begin
                if readkey=#27 then positie:=grootte;
                while keypressed do if readkey='' then ;
                end;
             end;
           ClrEOL;
           Write('100 %  ');
           if paginaeinde and (data<>#12) then
             begin
             TekenToPrn(#12);
             writeln('+ TOF');
             end else writeln;
           end else writeln('Geen pas2ns print data file');
         close(bestand);
         end;
       bestanden.Nextfile;
       end;
     end;
  until stop;

END.
