PROGRAM Pas2nsReclame;
{$A+,B-,D-,E+,F-,G-,I+,L+,N-,O-,R-,S+,V+,X+}
{$M 16384,0,655360}
{$IfDef debugall} {$D+} {$EndIf}
{$IfDef debugMain} {$D+} {$EndIf}

USES

  BGIDriv2,
  General,
  Crt,
  Graph;


CONST

  MaxLines = 50;
  AantalQixxen = 4;
  Script : integer = 0;
  MaxGrootte : integer = 50;


TYPE Tpoint=object
       X : integer;
       Y : integer;
       procedure Buitenscherm(var DX, DY : integer);
       procedure Move(var DX, DY : integer);
       procedure clear;
       end;
     TLine=object
       A : TPoint;
       B : TPoint;
       procedure move(var ADX,ADY,BDX,BDY : integer);
       procedure teken;
       procedure clear;
       private
       function lengte : integer;
       end;
     TQix=object
       BDX : integer;
       BDY : integer;
       ADX : integer;
       ADY : integer;
       top : integer;
       vorigetop : TLine;
       reeks : array[0..maxLines] of TLine;
       bottem : integer;
       procedure Clear;
       procedure Move;
       end;


PROCEDURE TScript; external;
{$L c:\bgikit\TSCR}


PROCEDURE ToBgi;

  var

    G, M : integer;

  begin

    RegisterBGIFont(@TScript);
    G:=detect;
    M:=0;
    InitGraph(G,M,'');
    Script:=InstallUserFont('TSCR');
    if graphresult<>grOK then halt;

  end;


procedure Action;

  var

    QIX : array[1..Aantalqixxen] of TQix;
    teller: integer;

  begin

    SetLineStyle(SolidLn,0,0);
    SetWriteMode(XORPut);
    for teller:=1 to aantalqixxen do QIX[teller].clear;
    repeat
      for teller:=1 to aantalqixxen do QIX[teller].Move;
    until keypressed;

  end;


PROCEDURE TQIX.Clear;

  var

    teller : integer;

  begin

    Vorigetop.clear;
    for teller:=0 to maxlines do reeks[teller].Clear;
    top:=-1;
    bottem:=-maxlines;
    ADX:=0;
    ADY:=0;
    BDX:=5;
    BDY:=5;

  end;


PROCEDURE TQix.Move;

  begin

    Top:=Top+1;
    if top>maxlines then top:=0;
    if top>0 then reeks[top]:=reeks[top-1] else reeks[0]:=reeks[maxlines];
    reeks[top].move(ADX,ADY,BDX,BDY);
    Reeks[top].teken;
    Bottem:=bottem+1;
    if bottem>=0 then
      begin
      if bottem>maxlines then bottem:=0;
      reeks[bottem].teken;
      end;
    BDX:=BDX+random(3)-1;
    if BDX<-5 then BDX:=-5;
    if BDX>5 then BDX:=5;
    BDY:=BDY+random(3)-1;
    if BDY<-5 then BDY:=-5;
    if BDY>5 then BDY:=5;
    ADX:=ADX+random(3)-1;
    if ADX<-5 then ADX:=-5;
    if ADX>5 then ADX:=5;
    ADY:=ADY+random(3)-1;
    if ADY<-5 then ADY:=-5;
    if ADY>5 then ADY:=5;

  end;


procedure TPoint.Buitenscherm;

  begin

    if X<0 then
      begin
      X:=0;
      DX:=-DX;
      end;
    if Y<0 then
      begin
      Y:=0;
      DY:=-DY
      end;
    if X>getMaxX then
      begin
      X:=getmaxX;
      DX:=-DX
      end;
    if Y>getmaxY then
      begin
      Y:=getmaxY;
      DY:=-DY;
      end;

  end;


procedure Tpoint.Clear;

  begin

    X:=0;
    Y:=0;

  end;


function TLine.Lengte;

  begin

    lengte:=round(XSqrt(sqr(B.X-A.X)+sqr(B.Y-A.Y)));

  end;


procedure TLine.move(var ADX, ADY, BDX, BDY : integer);

  begin

    if lengte>maxGrootte then
       begin
       BDX:=ADX;
       BDY:=ADY;
       end;
    A.Move(ADX,ADY);
    B.Move(BDX,BDY);

  end;


procedure TLine.teken;

  begin

    line(A.X,A.Y,B.X,B.Y);

  end;


procedure TLine.Clear;

  begin

    A.Clear;
    B.Clear;

  end;


procedure TPoint.Move(var DX,DY : integer);

  begin

    X:=X+DX;
    Y:=Y+DY;
    Buitenscherm(DX,DY);

  end;


BEGIN

  ToBgi;
  randomize;
  SetTextStyle(script,horizDir,5);
  OutTextXY(0,0,'News flash ...');
  SetLineStyle(3,0,0);
  Line(0,65,getMaxX,65);
  SetTextStyle(script,horizdir,2);
  OutTextXY(0,70,'We willen effe melden dat de eerste versie van');
  OutTextXY(0,100,'Pas2ns aangekomen is. Dit programma zet pascal-');
  OutTextXY(0,130,'programmas om naar NS-diagrammen. Ga even op zoek');
  OutTextXY(0,160,'in de directory');
  SetTextStyle(defaultfont, horizdir,1);
  OutTextXY(200,174,'C:\PASCAL\PAS2NS');
  SetTextStyle(script,horizdir,2);
  OutTextXY(345,160,'of contacteer onderstaande');
  OutTextXY(0,190,'maker.');
  SetTextStyle(defaultfont,horizdir,1);
  OutTextXY(0,230,'Werner Van Belle');
  OutTextXY(0,244,'Moortebeekstraat 72');
  OutTextXY(0,258,'1700 Dilbeek');
  Action;
  CloseGraph;

END.