UNIT Lijnen;

                                INTERFACE

USES Graph;

TYPE

  PLijn = ^TLijn;
  TLijn = object
          X1, Y1 : word;
          X2, Y2 : word;
          bovenkant : word;
          rechterkant : word;
          onderkant : word;
          procedure assign(IX1,IY1,IX2,IY2 : word);
          function XopY(Y : word) : word;
          function YopX(x : word) : word;
          function VoorkeurVoorYopX : boolean;
          procedure Teken;
          procedure XGerangschikt;
          procedure YGerangschikt;
          private
            procedure BerekenKanten;
            procedure Berekenonderkant;
            procedure Berekenbovenkant;
            procedure BerekenRechterkant;
          end;

procedure swap(var getal1, getal2 : word);


                                IMPLEMENTATION


procedure Tlijn.berekenbovenkant;

  begin

    if Y1<=Y2 then bovenkant:=Y1 else bovenkant:=Y2;

  end;


procedure Tlijn.berekenrechterkant;

  begin

    if X2>=X1 then rechterkant:=X2 else rechterkant:=X1;

  end;


procedure Tlijn.berekenonderkant;

  begin

    if Y2>=Y1 then onderkant:=Y2 else onderkant:=Y1;

  end;


procedure swap(var getal1, getal2 : word);

  var

    temp : word;

  begin

    temp:=getal2;
    getal2:=getal1;
    getal1:=temp;

  end;


procedure TLijn.XGerangschikt;

  begin

    if X1>X2 then
       begin
       swap(X1,X2);
       swap(Y1,Y2);
       BerekenKanten;
       end;

  end;


procedure Tlijn.YGerangschikt;

  begin

    if Y1>Y2 then
      begin
      swap(X1,X2);
      swap(Y1,Y2);
      berekenkanten;
      end;

  end;


function TLijn.VoorkeurVoorYopX : boolean;

  begin

    if abs(longint(Y2)-longint(Y1))>abs(longint(X2)-longint(X1))
       then VoorkeurVoorYopX:=false
       else VoorkeurVoorYopX:=true;

  end;


procedure TLijn.assign(IX1,IY1,IX2,IY2 : word);

  begin

    X1:=IX1;
    X2:=IX2;
    Y1:=IY1;
    Y2:=IY2;
    berekenkanten;

  end;


function TLijn.XopY(Y : word) : word;

  var

    factor1 : longint;
    factor2 : longint;
    factor3 : longint;
    Produkt : real;
    Uitkomst : word;

  begin

    factor1:=longint(y)-longint(y1);
    factor2:=longint(x2)-longint(X1);
    factor3:=longint(y2)-longint(y1);
    produkt:=factor1*factor2/factor3;
    UitKomst:=trunc(produkt)+x1;
    XopY:=Uitkomst;

  end;


function TLijn.YopX(X : word) : word;

  var

    factor1 : longint;
    factor2 : longint;
    factor3 : longint;
    Produkt : real;
    Uitkomst : word;

  begin

    factor1:=longint(x)-longint(x1);
    factor2:=longint(y2)-longint(y1);
    factor3:=longint(x2)-longint(x1);
    produkt:=factor1*factor2/factor3;
    Uitkomst:=trunc(produkt)+y1;
    YopX:=Uitkomst;

  end;


procedure TLijn.BerekenKanten;

  begin

    BerekenRechterkant;
    BerekenBovenkant;
    BerekenOnderKant;

  end;


procedure TLijn.Teken;

  begin

    Line(X1,Y1,X2,Y2);

  end;

END.
