UNIT P2ninst2;
{$X+,D+}

                                INTERFACE

USES

  Crt,
  Dos,
  app,
  Graph,
  views,
  dialogs,
  objects,
  drivers;


TYPE

  PIndicator = ^TIndicator;
  TIndicator = object(TView)
               ModIFied: Boolean;
               constructor Init(var Bounds: TRect);
               procedure handleevent(var event: tevent); virtual;
               PROCEDURE Draw; virtual;
               FUNCTION  GetPalette: PPalette; virtual;
               PROCEDURE SetState(AState: Word; Enable: Boolean); virtual;
               PROCEDURE SetValue(AModIFied: Boolean);
               END;
  TBlok = object
          EOF : boolean;
          remstellenmee : boolean;
          FileSize : longint;
          bestand : file OF char;
          positie : longint;
          LaatsteWoord : string;
          FUNCTION  ReadChar : char;
          FUNCTION  ReadWord : string;
          FUNCTION  volgENDWoord : string;
          FUNCTION  TotEindeLijn : string;
          PROCEDURE Reset(IPad : pathstr);
          PROCEDURE done;
          PROCEDURE Onthoud;
          PROCEDURE remember;
          private
              OPositie : longint;
              OLW      : string;
              Orem     : boolean;
              OEOF     : boolean;
          END;

CONST

  cmAbout = 100;
  cmNewFont = 101;
  cmOpen    = 102;
  cmOpenFont = 103;
  cmGlobL    = 104;
  cmGlobR    = 105;
  cmGlobU    = 106;
  cmGlobD    = 107;
  cmUp       = 108;
  cmDown     = 109;
  cmLeft     = 110;
  cmRight    = 111;
  cmGlobX    = 112;
  cmGlobY    = 113;
  cmGoto     = 114;
  cmFlipX    = 115;
  cmFlipY    = 116;
  cmGlobI    = 117;
  cmInvers   = 118;
  cmCopy     = 119;
  cmWissel   = 120;
  cmZoomChar = 121;
  cmNextChar = 122;
  cmPrevChar = 123;
  cmLastChar = 124;
  cmFirstChar = 125;
  cmZetWaarde = 126;
  cmVeranderd = 127;
  cmNietVeranderd = 128;
  cmSave             = 129;
  cmSaveAs           = 130;
  cmSaveAll          = 131;
  cmPrint            = 132;
  cmCapitalize       = 133;
  cmupperCase        = 134;
  cmLowerCase        = 135;
  cmUpperCaseRegel   = 136;
  cmLowerCaseRegel   = 137;
  cmDeleteRegel      = 138;
  cmInsertRegel      = 139;
  cmVeranderRegel    = 140;
  cmNewTaalWindow    = 141;
  cmOpenTaalWindow   = 142;
  cmDosshell         = 143;
  cmChDir            = 144;
  cmClearScreen      = 145;
  cmRedrawScreen     = 146;
  cmNoCommand        = 147;
  cmSetVerplaatst    = 148;
  csWindowAfhankelijk = [cmPrint, cmSave, cmSaveAs, cmSaveAll, cmTile,
  cmCascade,cmNext];
  CIndicator         = #2#3;
  TweedeMacht : array[0..7] OF byte = (128,64,32,16,8,4,2,1);
  WoordTekens = ['a'..'z', 'A'..'Z', '0'..'9', '_', '[', ']'];
  sdHelp             = 1;
  sdExit             = 2;
  sdMenu             = 4;
  sdClose            = 8;
  sdZoom             = 16;
  sdResize           = 32;
  sdNext             = 64;
  sdAll = sdHelp+SdExit+sdNext+SdResize+sdZoom+sdClose+SdMenu;
  hcBeginMenus = 1000;
  hcEindeMenus = 1052;
  hcGeblokeerd = 10000;
  WagenTerug  = #13;
  LineFeed    = #10;
  Escape      = #27;
  Return      = Wagenterug+lineFeed;
  EnkeleDichtheid      = #27'K';
  DubbeleDichtheid     = #27'L';
  ViervoudigeDichtheid = #27'Z';
  OnderstreepAan       = #27#45#1;
  OnderstreepUit       = #27#45#0;
  MoveDown             = #27'J';
  EindeBlad            = #12;
  EndOffile            = #26;
  DraftKwaliteit       = Escape+'x'#0;
  LQ                   = Escape+'x'#1;


VAR

  WindowNummer   : word;


FUNCTION Strip(str : string) : string;
FUNCTION StripBEGIN(str : string) : string;
FUNCTION StripEinde(str : string) : string;
FUNCTION UpcStr(str : string) : string;
FUNCTION StripLine(str : string) : string;
FUNCTION ReservedWord(str : string) : boolean;
FUNCTION DirExists(dir : dirstr) : boolean;
FUNCTION FileExists(pad : pathstr) : boolean;
FUNCTION DestilleerDir(pad : pathstr) : dirstr;
FUNCTION DatumStr : string;
FUNCTION Splitbyte(waarde : byte) : string;
FUNCTION berekenbyte(str : string) : byte;
FUNCTION ExecDialog(P: PDialog; Data: Pointer): Word;
FUNCTION BitNummer(Nummer : byte; gegeven : byte; NC, IC : word) : word;
FUNCTION Byte2str(waarde : byte) : string;
PROCEDURE Splits(str : string; var eerstewoord, derest : string);


                                IMPLEMENTATION


(***************************************************************)
(*                                                             *)
(*                 TIndicator                                  *)
(*                                                             *)
(***************************************************************)
constructor TIndicator.Init(var Bounds: TRect);

  var

    R: TRect;

  BEGIN

    TView.Init(Bounds);
    GrowMode := gfGrowLoY + gfGrowHiY;
    modIFied:=false;

  END;


PROCEDURE TIndicator.Draw;

  var

    Color: Byte;
    Frame: Char;
    B: TDrawBuffer;

  BEGIN

    IF State AND sfDragging = 0
       THEN
         BEGIN
         Color := GetColor(1);
         Frame := #205;
         END
       ELSE
         BEGIN
         Color := GetColor(2);
         Frame := #196;
         END;
    MoveChar(B, Frame, Color, Size.X);
    IF Modified THEN WordRec(B[1]).Lo := 15;
    WriteBuf(0, 0, Size.X, 1, B);

  END;


FUNCTION TIndicator.GetPalette: PPalette;

  const

    P: string[Length(CIndicator)] = CIndicator;

  BEGIN

    GetPalette := @P;

  END;


PROCEDURE TIndicator.HandleEvent(var event : tevent);

  begin

    if event.what=evmousedown then
       begin
       if mouseinview(event.where) then
          begin
          message(owner,evCommand,cmSave,nil);
          clearevent(event);
          end;
       end;


  end;


PROCEDURE TIndicator.SetState(AState: Word; Enable: Boolean);

  BEGIN

    TView.SetState(AState, Enable);
    IF AState = sfDragging THEN DrawView;

  END;


PROCEDURE TIndicator.SetValue(AModIFied: Boolean);

  BEGIN

    IF ModIFied <> AModIFied THEN
      BEGIN
      ModIFied := AModIFied;
      DrawView;
      END;

  END;


(***************************************************************)
(*                                                             *)
(*                 Algemeen                                    *)
(*                                                             *)
(***************************************************************)
PROCEDURE Splits(str : string; var eerstewoord, derest : string);

  var

    stop : boolean;
    positie : word;
    result : string;

  BEGIN

    positie:=1;
    result:='';
    stop:=false;
    while not(positie>length(str)) AND not(stop) do
      BEGIN
      IF str[positie] in woordtekens THEN
         BEGIN
         result:=result+str[positie];
         END ELSE stop:=true;
      inc(positie);
      END;
    EersteWoord:=stripline(result);
    Derest:=stripline(copy(str,positie,length(str)-positie+1));

  END;


FUNCTION Splitbyte(waarde : byte) : string;

  VAR

    t : string;
    w : byte;

  BEGIN

    w := 128;
    t:='';
    REPEAT
     IF waarde AND w > 0 THEN t:=t+'x' ELSE t:=t+'.';
     w := w shr 1;
    UNTIL w=0;
    splitbyte:=t;

  END;


FUNCTION berekenbyte(str : string) : byte;

  var

    teller : byte;
    waarde : byte;

  BEGIN

    waarde:=0;
    for teller:=1 to 8 do IF str[teller]='x' THEN waarde:=waarde+tweedemacht[teller-1];
    berekenbyte:=waarde;

  END;


FUNCTION ExecDialog(P: PDialog; Data: Pointer): Word;

  var

    Result: Word;

  BEGIN

    Result := cmCancel;
    P := PDialog(Application^.ValidView(P));
    IF P <> nil THEN
      BEGIN
      IF Data <> nil THEN P^.SetData(Data^);
      Result := DeskTop^.ExecView(P);
      IF (Result <> cmCancel) AND (Data <> nil) THEN P^.GetData(Data^);
      Dispose(P, Done);
      END;
    ExecDialog := Result;

  END;


FUNCTION BitNummer(Nummer : byte; gegeven : byte; NC, IC : word) : word;

  BEGIN

    nummer:=nummer AND 7;
    gegeven:=gegeven AND Tweedemacht[nummer];
    IF gegeven<>0 THEN bitnummer:=IC ELSE bitnummer:=NC;

  END;


FUNCTION Byte2str(waarde : byte) : string;

  var

    str2   : string;

  BEGIN

    str(waarde,str2);
    Byte2str:=str2;

  END;


FUNCTION FileExists(pad : pathstr) : boolean;

  var

    rommelrec : searchrec;

  BEGIN

    IF (pos('*',pad)=0) AND (pos('?',pad)=0) THEN
       BEGIN
       findfirst(pad,archive,rommelrec);
       IF doserror=0 THEN
          BEGIN
          FileExists:=true;
          exit;
          END;
       END;
    FileExists:=false;

  END;


FUNCTION DatumStr : string;

  CONST

    days : array [0..6] OF String[9] =('Zondag','MaANDag','Dinsdag',
                                       'Woensdag','Donderdag','Vrijdag',
                                       'Zaterdag');

  VAR

    Y, M, D, DOW : Word;

  FUNCTION NaarStr(waarde : word) : string;

    var

      str : string;

    BEGIN

      system.str(waarde,str);
      Naarstr:=str;

    END;


  BEGIN

    GetDate(y,m,d,dow);
    DatumStr:=days[dow]+', '+Naarstr(d)+ '/'+Naarstr(m)+'/'+naarstr(y);

  END;


FUNCTION DestilleerDir(pad : pathstr) : dirstr;

  var

    N : NameStr;
    E : ExtStr;
    D : DirStr;

  BEGIN

    IF (Pos('*',pad)<>0) or (Pos('?',pad)<>0) THEN
       BEGIN
       Fsplit(Pad,D,N,E);
       DestilleerDir:=D;
       END ELSE destilleerdir:=pad;

  END;


FUNCTION DirExists(dir : dirstr) : boolean;

  var

    rommelrec : searchrec;

  BEGIN

    IF dir[length(dir)]='\' THEN dir[0]:=chr(ord(dir[0])-1);
    Findfirst(dir,directory,rommelrec);
    IF doserror<>0 THEN DirExists:=false ELSE direxists:=true;

  END;


FUNCTION UpcStr(str : string) : string;

  var

    teller : byte;

  BEGIN

    for teller:=1 to length(str) do str[teller]:=upCASE(str[teller]);
    upcstr:=str;

  END;


FUNCTION ReservedWord(str : string) : boolean;

  BEGIN

    str:=strip(str);
    IF (str='ELSE')        or (str='END')        or
       (str='BEGIN')       or (str='IF')         or
       (str='THEN')        or (str='CASE')       or
       (str='DOWNTO')      or (str='FOR')        or
       (str='FUNCTION')    or (str='PROCEDURE')  or
       (str='WHILE')       or (str='WITH')       or
       (str='REPEAT')      or (str='UNTIL')      or
       (str='DO')          or (str='TO')         or
       (str='CONSTRUCTOR') or (str='DESTRUCTOR')
       THEN reservedword:=true
       ELSE reservedword:=false;

  END;


FUNCTION StripBEGIN(str : string) : string;

  const

    BEGINlijntekens = [' ', #9];

  BEGIN

    while (length(str)<>0) AND (str[1] in BEGINlijntekens) do delete(str,1,1);
    stripBEGIN:=str;

  END;


FUNCTION StripEinde(str : string) : string;

  const

    BEGINlijntekens = [' ', #9];

  BEGIN

    while (length(str)<>0) AND (str[length(str)] in BEGINlijntekens) do delete(str,length(str),1);
    stripeinde:=str;

  END;


FUNCTION StripLine(str : string) : string;

  BEGIN

    Stripline:=StripBEGIN(stripeinde(str));

  END;


FUNCTION Strip(str : string) : string;

  var

    teller : byte;

  BEGIN

    while not(str[1] in woordtekens) AND (length(str)>0) do delete(str,1,1);
    while not(str[length(str)] in woordtekens) AND (length(str)>0) do delete(str,length(str),1);
    for teller:=1 to length(str) do str[teller]:=upCASE(str[teller]);
    Strip:=str;

  END;


(***************************************************************)
(*                                                             *)
(*                 TBlok                                       *)
(*                                                             *)
(***************************************************************)
PROCEDURE TBlok.Onthoud;

  BEGIN

    OPositie:=positie;
    OEOF:=EOF;
    OLW:=LaatsteWoord;
    ORem:=RemsTellenMee;

  END;


PROCEDURE TBlok.Remember;

  BEGIN

    positie:=Opositie;
    EOF:=OEOF;
    LaatsteWoord:=OLW;
    RemsTellenMee:=ORem;

  END;


FUNCTION TBlok.VolgENDWoord : string;

  BEGIN

    OntHoud;
    VolgENDwoord:=readword;
    Remember;

  END;


FUNCTION TBLok.TotEindeLijn : string;

  var

    eindebereikt : boolean;
    str : string;

  BEGIN

    str:='';
    eindebereikt:=false;
    while not(EOF) AND not(eindebereikt) do
      BEGIN
      str:=str+Readchar;
      IF (str[length(str)]=#10) AND (str[length(str)-1]=#13) THEN eindebereikt:=true;
      END;
    IF eindebereikt THEN str[0]:=chr(length(str)-2);
    totEindeLijn:=str;

  END;


PROCEDURE TBlok.Done;

  BEGIN

    Close(bestand);

  END;


FUNCTION TBlok.ReadWord : string;

  var

    str : string;
    teken : char;

  BEGIN

    teken:=readchar;
    str:='';
    while (not(teken in WoordTekens)) AND (not EOF) do teken:=readchar;
    IF EOF THEN
       BEGIN
       readword:='';
       exit;
       END;
    str:=str+teken;
    teken:=readchar;
    while (teken in WoordTekens) AND (not EOF) do
      BEGIN
      str:=str+teken;
      teken:=readchar;
      END;
    IF EOF AND (teken in woordTekens) THEN str:=str+teken;
    IF not EOF THEN positie:=positie-1;
    laatstewoord:=str;
    readword:=str;

  END;


FUNCTION TBlok.ReadChar : char;

  var

    teken : char;
    volgENDteken : char;

  BEGIN

    Seek(bestand,positie);
    read(bestand,teken);
    positie:=positie+1;
    IF positie<filesize THEN read(bestand,volgENDteken) ELSE volgENDteken:='~';
    IF not remstellenmee AND ((teken='{') or ((teken='(') AND (volgENDteken='*'))) THEN
       BEGIN
       IF teken='{' THEN positie:=positie+1 ELSE positie:=positie+2;
       while (positie<filesize) AND (teken<>'}') AND not((teken='*') AND (volgENDteken=')')) do
         BEGIN
         seek(bestand,positie);
         read(bestand,teken);
         read(bestand,volgENDteken);
         positie:=positie+1;
         END;
       IF positie<filesize THEN
          BEGIN
          IF (teken='*') AND (volgENDteken=')') THEN
            BEGIN
            seek(bestand,positie);
            read(bestand,teken);
            IF positie<filesize THEN read(bestand,teken);
            positie:=positie+2;
            END ELSE
            BEGIN
            seek(bestand,positie);
            read(bestand,teken);
            positie:=positie+1;
            END;
          END;
       END;
    EOF:=false;
    IF positie>=FileSize THEN
       BEGIN
       EOF:=true;
       positie:=FileSize-1;
       END;
    readchar:=teken;

  END;


PROCEDURE TBLok.Reset(IPad : pathstr);

  BEGIN

    Assign(bestand,IPad);
    system.Reset(bestand);
    positie:=0;
    filesize:=system.filesize(bestand);
    EOF:=false;
    remstellenmee:=false;
    IF positie>=filesize THEN
       BEGIN
       EOF:=true;
       positie:=filesize-1;
       END;

  END;

END.
